//
//  FileItem.c
//  folder
//
//  Created by kunii on 2013/11/18.
//  Copyright (c) 2013年 國居貴浩. All rights reserved.
//

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include "Item.h"

//  Item構造体を初期化する。
//      nameに9バイト以上の文字列をわたしてはいけない
static Item* initFileItem(Item* item, const char* name)
{
    strcpy(item->name, name);       //  nameに指定される名前をコピーする
    return item;
}

//  itemで指定されるItem構造体の名前を [ ] で囲んでコンソールに表示する。
static void printFileItem(Item* item, int indent)
{
    //  indentで指定される数だけ半角スペースを表示してから名前を表示する。
    for (int i = 0; i < indent; i++) printf(" ");
    printf("[%s]\n", item->name);   //  ファイルなので名前を []　で囲んでから表示
}

//  Item構造体を破棄する。
static void deallocFileItem(Item* item)
{
    free(item); //  itemが示すItem構造体用に確保したメモリ領域を破棄する
}

Item* FileItemAlloc()
{
    Item* item = malloc(sizeof(Item));
    item->init = initFileItem;
    item->print = printFileItem;
    item->dealloc = deallocFileItem;
    return item;
}
